<?php
/**
 * tsDomaincheck Whois Lookup
 * 
 * @version    1.0.0
 * @copyright  Copyright (c) 2013 Top-Side.de
 * 
 * IDN Umwandlung: Net_IDNA2
 * http://pear.php.net/package/Net_IDNA2/
 *
 */

include_once("config.php");
include_once("whoisservers.php");
if(!headers_sent())
	header("Content-Type: text/html; charset=UTF-8");
if(!isset($_SESSION))
	session_start();

function check_domain($domain, $tld, $whoisserver)
{
	$fp = @fsockopen($whoisserver, 43, $errno, $errstr, 5);
	if(!$fp)
		return "<strong>Fehler</strong><br />".$errstr." (".$errno.")\n";
	else
	{
		if($tld != "de" && !preg_match("/^[a-zA-Z0-9-]*$/", $domain))
		{
			try
			{
				require_once("idna2.php");
				$idn = Net_IDNA2::getInstance();
				$domain = $idn->encode($domain);
			}
			catch(Exception $e)
			{
				return "<strong>Fehler</strong><br />".$e->getMessage()."\n";
			}
		}
		$flag = "";
		if($tld == "de")
			$flag = "-T dn ";
		fwrite($fp, $flag.$domain.".".$tld."\r\n");
		$string = "";
		while(!feof($fp))
			$string .= fread($fp, 128);
		fclose($fp);
		return $string;
	}
}

$domain = $_POST['domain'];
$tld = $_POST['tld'];
if(!preg_match("/^[^_\.\/]{1,}$/", $domain))
	echo "<span class=\"error\">\nung&uuml;ltiger Domainname</span>\n";
else
{
	function print_domain($domain, $tld, $whoisservers)
	{
		global $limit_exceeded;
		$status_free = "not found|no match|nothing found|not have an entry|status: available|is free|status: free";
		$status_invalid = "status: invalid|invalid pattern|not a valid domain|invalid request|not understand the query|";
		$status_invalid .= "error for|invalid domain|invalid characters|idn unsupported|unassignable|currently restricted|not allowed|invalid parameter";
		$status_limit = "limit exceeded";

		$string = check_domain($domain, $tld, $whoisservers[$tld]);
		preg_match_all("/Whois Server: (.*?)\n/i", $string, $matches);
		if(isset($matches[1][0]))
			$string = check_domain($domain, $tld, $matches[1][0]);
		if(preg_match("/Fehler/", $string))
		{
			echo "<tr><td>".$domain.".<strong>".$tld."</strong></td><td><span class=\"error\">Fehler</span>";
			echo " (<a href=\"includes/popup.php?tld=".$tld."\" onclick=\"window.open('includes/popup.php?tld=".$tld."','Details','width=800,height=600,scrollbars=yes'); return false\">Details</a>)";
			echo "</td></tr>\n";
			$_SESSION['details'][$tld] = $string;
		}
		else
		{
			if(preg_match("/".$status_free."/i", preg_replace("/\s\s+|\t/", " ", $string)))
				echo "<tr><td>".$domain.".<strong>".$tld."</strong></td><td class=\"success\">ist frei!</td></tr>\n";
			elseif(preg_match("/".$status_invalid."/i", $string))
				echo "<tr><td>".$domain.".<strong>".$tld."</strong></td><td class=\"error\">ung&uuml;ltig</td></tr>\n";
			elseif(preg_match("/".$status_limit."/i", $string))
			{
				echo "<tr><td>".$domain.".<strong>".$tld."</strong></td><td class=\"error\">Abfragelimit erreicht *</td></tr>\n";
				$limit_exceeded = true;
			}
			else
			{
				echo "<tr><td>".$domain.".<strong>".$tld."</strong></td><td><span class=\"error\">ist belegt</span>";
				echo " (<a href=\"includes/popup.php?tld=".$tld."\" onclick=\"window.open('includes/popup.php?tld=".$tld."','Details','width=800,height=600,scrollbars=yes'); return false\">Details</a>)";
				echo "</td></tr>\n";
				$_SESSION['details'][$tld] = "<pre>\n".$string."</pre>";
			}
		}
	}
	$limit_exceeded = false;
	echo "<table class=\"list\">\n";
	if($tld == "all")
	{
		foreach($whoisservers as $tld_ => $value)
			print_domain($domain, $tld_, $whoisservers);
	}
	else
		print_domain($domain, $tld, $whoisservers);
	echo "</table>\n";
	if($limit_exceeded)
		echo "<span>(* Bitte versuchen Sie es in ein paar Minuten erneut)</span>\n";
}
?>